#ifndef MSP_DATAFILE_META_H_
#define MSP_DATAFILE_META_H_

#include <msp/core/meta.h>

namespace Msp {
namespace DataFile {

/**
Helper struct to determine whether a Loader has a Collection typedef.
*/
struct CheckCollectionType: Sfinae
{
	template<typename T>
	static Yes f(typename T::Collection *);
	using Sfinae::f;
};

template<typename T> struct NeedsCollection: Sfinae::Evaluate<CheckCollectionType, T> { };

} // namespace DataFile
} // namespace Msp

#endif
